/*
  Most systems limit the maximum number of open files to 1024 (ulimit -n).
  This program tests if we are able to enlarge this limit.
*/
#define FD_SETSIZE 1080
#define FOPEN_MAX 1070
#define STREAM_MAX 1090
#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
main(){
  FILE *f1;
  int i;
  struct rlimit lbuf;
  i=getrlimit(RLIMIT_NOFILE,&lbuf);
  printf(" cur=%d max=%d ret=%d\n",(int)lbuf.rlim_cur,(int)lbuf.rlim_max,i);
  lbuf.rlim_cur+=20;
  lbuf.rlim_max+=20;
  i=getrlimit(RLIMIT_NOFILE,&lbuf);
  getrlimit(RLIMIT_NOFILE,&lbuf);
  printf(" cur=%d max=%d ret=%d\n",(int)lbuf.rlim_cur,(int)lbuf.rlim_max,i);
  for(i=0;i<2048;i++){
    f1=fopen("/dev/zero","r");
    if(!f1) break;
  }
  printf(" max_open_files=%d\n",i); perror("");
}
